<template>
  <div class="bg-white w-full lg:w-722 px-4 py-8 md:p-8 lg:p-14">
    <h2
      id="radio_group_label"
      class="font-primary-font-bold text-black text-lg md:text-base lg:text-xl mb-10 md:mb-6 lg:mb-12"
    >
      Please tell us why you are turning off auto-refills.
    </h2>
    <div class="w-full">
      <ValidationObserver ref="auto_refill_validation_observer">
        <div role="radiogroup" aria-labelledby="radio_group_label">
          <button
            v-for="(item, index) in allReasons"
            ref="question_btn"
            :key="index"
            :class="
              selectedSurvey == item.id ? 'border-black' : 'border-grey-20'
            "
            class="bg-white font-primary-font-light text-sm md:text-base text-black border rounded md:rounded-md px-4 py-5 md:px-6 md:py-4 leading-5 md:leading-6 w-full text-left mb-6 md:mb-4 focus:outline-none focus:ring-1 focus:ring-black"
            role="radio"
            :aria-checked="selectedSurvey == item.id"
            :aria-rowindex="index"
            @click="
              selectedSurvey = item.id
              selectedOption = item.question
            "
          >
            {{ item.question }}
          </button>
        </div>
        <div
          v-if="selectedOption == 'Other'"
          class="border rounded md:rounded-md px-4 py-5 md:px-6 md:py-4 leading-5 md:leading-6 mb-10 md:mb-8 lg:mb-12 w-full focus-within:border-black"
          :class="selectedOption == 'Other' ? 'border-black' : 'border-grey-20'"
        >
          <label
            class="font-primary-font-light text-black text-sm md:text-base w-full block leading-5 md:leading-6 for"
            for="turningoffothers"
            >Other</label
          >
          <textarea
            id="turningoffothers"
            v-model="otherReason"
            maxlength="200"
            class="font-primary-font-light text-sm md:text-base text-black w-full h-100 md:h-72 mt-4 md:mt-2 lg:mt-4 rounded resize-none block border-none focus:border-none focus:outline-none p-0 focus:shadow-none focus:ring-0"
            aria-labelledby="others"
            aria-describedby="info"
            placeholder="200 character max"
          ></textarea>
        </div>
        <div class="flex items-center flex-col mt-6 md:mt-4 lg:mt-8">
          <MkPrimaryButton
            class="font-primary-font-regular text-base lg:text-xl mb-8 md:mb-6 lg:mb-10 w-full md:w-210 lg:w-243"
            :loading="loading"
            button-title="Turn off auto-refills"
            :disabled="buttonDisabled"
            @click="turnOffAutoRefill()"
          />
          <MkTerritoryButton
            class="w-full md:w-210 lg:w-243 pt-2 pb-1.5 leading-6 h-10"
            button-title="Cancel"
            @click="$emit('emitted-event', 'cancel')"
          />
        </div>
      </ValidationObserver>
    </div>
  </div>
</template>

<script>
import { ValidationObserver } from 'vee-validate'
import { mapState } from 'vuex'
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue'
import MkTerritoryButton from '~/components/D2C/atoms/MkTerritoryButton.vue'

export default {
  name: 'MkTurningOffAutoRefills',
  components: { MkPrimaryButton, MkTerritoryButton, ValidationObserver },
  props: {
    selectedSubscription: {
      type: Object,
      default: null,
    },
  },
  data() {
    return {
      buttonDisabled: true,
      selectedSurvey: '',
      loading: false,
      selectedOption: '',
      otherReason: '',
      allReasons: [],
    }
  },
  computed: {
    ...mapState('USER_STORE', ['SURVEYS']),
    turnOffRefill() {
      this.allReasons = this.SURVEYS
      return this.SURVEYS
    },
  },
  watch: {
    selectedSurvey: {
      deep: true,
      handler() {
        if (this.selectedSurvey) {
          this.buttonDisabled = false
        }
      },
    },
    selectedOption: {
      deep: true,
      handler() {
        if (this.selectedOption === 'Other') {
          this.allReasons = this.turnOffRefill.filter(
            (item) => item.question !== 'Other'
          )
        } else {
          this.allReasons = this.turnOffRefill
        }
      },
    },
  },
  mounted() {
    this.getSurvey()
  },
  methods: {
    async getSurvey() {
      await this.$store.dispatch('USER_STORE/GET_SURVEYS', 'D2C')
      this.allReasons = this.turnOffRefill
      const self = this
      this.$nextTick().then(function () {
        self.$refs.question_btn[0].focus()
      })
    },
    async turnOffAutoRefill() {
      const valid = await this.$refs.auto_refill_validation_observer.validate()
      try {
        let $data = {}
        if (valid && this.selectedSurvey) {
          this.loading = true
          $data = {
            container: this.selectedSubscription.container,
            key: this.selectedSubscription.key,
            data: {
              action: 'TURN_OFF',
              surveyQuestionId: this.selectedSurvey,
            },
          }
        }
        if (this.selectedOption === 'Other') {
          $data.data.other = this.otherReason
          delete $data.data.surveyQuestionId
        }
        await this.$store.dispatch(
          'USER_STORE/UPDATE_SUBSCRIPTION_QUANTITY',
          $data
        )
        this.loading = false
        this.$emit('emitted-event', 'turn-off-success')
      } catch (exp) {
        this.loading = false
      }
    },
  },
}
</script>
